/*
	LUSScreenSaver
	Copyright (C) 2003-2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_H_

#include <qstring.h>
#include <qobject.h>
#include <qfile.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qmessagebox.h>
#include <qwindowsystem_qws.h>
#include <qpe/qlibrary.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/qpeapplication.h>
#include <qpe/global.h>

class LUSScreenSaverWidget;
class LUSPassInputDlg;

class LUSScreenSaver : public QWSScreenSaver
{
public:
	LUSScreenSaver();
	virtual ~LUSScreenSaver();
	void restore();
	bool save( int );
	
	void VictimDlg();
	int ExecOKDlg( const char* );
	int ExecYesNoDlg( const char* );
	int ExecBaseDlg( const char* , int , int = QMessageBox::NoButton );
	void SetForceExecFlag();
	void SetScreenSaverMode( int );
	void AuthDone( int );
	void AuthDel();
	bool IsAppLocked();
	void DoLockedSuspend();
	
private:
	bool ShowScreenSaver();
	void RestartKeyHelper();
	void PauseKeyHelper();
	QLibrary* m_pSaver;
	QLibrary* m_pAuthDlg;
	bool m_bForceExecuted;
	int m_nDisableSuspend;
	int m_nTempMode;

};

#endif /* _LESS_UNSATICEFACTORY_SCREENSAVER_H_ */

